﻿package {
	
	import mdm.*;
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	import flash.net.*;
	import flash.ui.*;
	import flash.text.*
	import flash.filters.BlurFilter;
	import flash.media.*;
	import flash.geom.Rectangle;

	public class SoundPlayer {
		
		private var rootclip:MovieClip;
		private var soundplayer:MovieClip;
		private var mascara1:MovieClip;
		private var mascara2:MovieClip;
		private var marque1:MovieClip;
		private var marque2:MovieClip;
		private var plaqueupdate:MovieClip;
		private var media:String;
		private var type:String;
		private var urlvotes:String;
		private var url:String;
		private var urlupdate:String;
		private var urldownload:String;
		private var xmlobject:XML;
		private var xmlupdate:XML;
		private var ns:NetStream;
		private var sound:Sound;
		private var channel:SoundChannel;
		private var streaming:NetStream;
		public var statusplay:Boolean;
		private var statusdrag:Boolean;
		private var statusaudio:Boolean;
		private var position:Number;
		private var posvideo:Number;
		private var apptype:String;
		private var totaltime:Number;
		private var currentversion;
		private var version:String;
		private var important:String;
		private var idtema:String;
		private var socialurl:String;
		private var socialsubject:String;
		public var counter:Number = 0;
		
		public function SoundPlayer(root:MovieClip,apptype:String,currentversion:String,urlvotes:String,url:String,urldownload:String,urlstreaming:String,socialurl:String){
			this.apptype = apptype;
			this.currentversion = currentversion;
			this.urlvotes = urlvotes;
			this.urlupdate = url;
			this.urldownload = urldownload;
			this.url = urlstreaming;
			this.socialurl = socialurl;
			if(this.apptype == "desktop"){
				trace("Soy el widget");
				this.loadXMLupdate();
			}else{
				trace("Soy la barrita");
				this.callNewTrack();
			}
			this.rootclip = root;
			this.rootclip.plaque.visible = false;
			this.soundplayer = new Playerbar();
			this.rootclip.addChild(this.soundplayer);
			this.placePlayer();
			this.mascara1 = new Mascara();
			this.mascara2 = new Mascara();
			this.rootclip.addChild(this.mascara1);
			this.rootclip.addChild(this.mascara2);
			this.marque1 = new Marque();
			this.marque2 = new Marque();
			this.rootclip.addChild(this.marque1);
			this.rootclip.addChild(this.marque2);
			this.marque1.mask = this.mascara1;
			this.marque2.mask = this.mascara2;
			this.placeMarque();
		}
		
		private function setButtons():void{
			this.rootclip.btsocial1.addEventListener(MouseEvent.CLICK, onClicksocial);
			this.rootclip.btsocial1.ruta = "http://www.myspace.com";
			this.rootclip.btsocial1.buttonMode = true;
			
			this.rootclip.btsocial2.addEventListener(MouseEvent.CLICK, onClicksocial);
			this.rootclip.btsocial2.ruta = "http://www.facebook.com/share.php?u=" + this.socialurl + "&t=" + this.socialsubject;
			this.rootclip.btsocial2.buttonMode = true;
			
			this.rootclip.btsocial3.addEventListener(MouseEvent.CLICK, onClicksocial);
			this.rootclip.btsocial3.ruta = "http://twitter.com/home?status=" + this.socialsubject + ":" + this.socialurl;
			this.rootclip.btsocial3.buttonMode = true;
			
			this.rootclip.btsocial4.addEventListener(MouseEvent.CLICK, onClicksocial);
			this.rootclip.btsocial4.ruta = "http://www.google.com/bookmarks/mark?op=edit&bkmk=" + this.socialurl + "&title=" + this.socialsubject;
			this.rootclip.btsocial4.buttonMode = true;
			
			this.rootclip.btsocial5.addEventListener(MouseEvent.CLICK, onClicksocial);
			this.rootclip.btsocial5.ruta = "http://digg.com/submit?url=" + this.socialurl + "&title=" + this.socialsubject;
			this.rootclip.btsocial5.buttonMode = true;
			
			this.rootclip.btsocial6.addEventListener(MouseEvent.CLICK, onClicksocial);
			this.rootclip.btsocial6.ruta = "http://hi5.com";
			this.rootclip.btsocial6.buttonMode = true;
		}
		
		private function onClicksocial(event:MouseEvent):void{
			var targetURL = new URLRequest(event.target.ruta);
			navigateToURL(targetURL,"_blank");
		}
		
		
		private function placeMarque():void{
				this.marque1.alpha = 0;
				this.marque2.alpha = 0;
			if(this.apptype == "desktop"){
				this.mascara1.x = 136;
				this.mascara1.y = 167;
				this.mascara2.x = 136;
				this.mascara2.y = 167;
			}else if(this.apptype == "bar"){
				this.mascara1.x = 500;
				this.mascara1.y = 23;
				this.mascara2.x = 500;
				this.mascara2.y = 23;
			}
		}
		
		private function MoveMarque(m1:MovieClip,m2:MovieClip):void{
			m1.x-= 2;
			m2.x-= 2;
			if(m1.x <= this.mascara1.x - m1.width){
				m1.x = m2.x + m2.width + 10;
			}
			if(m2.x <= this.mascara1.x - m2.width){
				m2.x = m1.x + m1.width + 10;
			}
		}
		
		private function callNewTrack():void{
			if(this.sound){
				var transform1 = new SoundTransform(0);
				this.channel.soundTransform = transform1;
				this.sound = null;
				this.rootclip.plaque.visible = false;
			}else if(this.ns){
				var sTrans = new SoundTransform();
				sTrans.volume = 0;
				this.ns.soundTransform = sTrans;
				var nc = new NetConnection();
				nc.connect(null);
				this.ns = new NetStream(nc);
				this.ns = null;
				this.rootclip.plaque.visible = true;
			}
			this.loadXML();
			//Incrementa el estado de minimizar, si llega a 3 se minimiza la aplicación!
			if(this.apptype == "desktop"){
				if(this.counter >= 3){
					trace("Acabo de minimizar");
					mdm.Forms.getFormByName("bacardi").minimize();
					this.counter = 0;
				}else{
					this.counter+= 1;
				}
			}
			//
			
		}
		
		private function loadXMLupdate() {
			var loader:URLLoader = new URLLoader();
			var request:URLRequest = new URLRequest(this.urlupdate);
			loader.addEventListener(Event.COMPLETE, loadUpdate);
			loader.load(request);
		}
		
		private function loadXML() {
			var loader:URLLoader = new URLLoader();
			var request:URLRequest = new URLRequest(this.url);
			loader.addEventListener(Event.COMPLETE, loadComplete);
			loader.load(request);
		}

		private function loadComplete(event:Event):void{
			this.xmlobject = XML(event.target.data);
			XML.ignoreWhitespace = true;
			var mediastream = unescape(this.xmlobject.streaming.@media).replace(/\+/g," ");
			this.media = mediastream;
			this.type = this.xmlobject.streaming.@type;
			this.idtema = this.xmlobject.streaming.@idtema;
			var readableString = unescape(this.xmlobject.streaming.@nametrack).replace(/\+/g," ");
			this.socialsubject = readableString;
			this.marque1.nametrack.text = readableString;
			this.marque2.nametrack.text = readableString;
			this.marque1.nametrack.autoSize = TextFieldAutoSize.LEFT;
			this.marque2.nametrack.autoSize = TextFieldAutoSize.LEFT;
			
			this.marque1.alpha = 1;
			this.marque2.alpha = 1;
			if(this.apptype == "desktop"){
				this.marque1.x = 136;
				this.marque1.y = 172;
				this.marque2.x = this.marque1.x + this.marque1.width + 10;
				this.marque2.y = 172;
			}else if(this.apptype == "bar"){
				this.marque1.x = 440;
				this.marque1.y = 23;
				this.marque2.x = this.marque1.x + this.marque1.width + 10;
				this.marque2.y = 23;
			}
			
			if(this.type == "video"){
				this.rootclip.plaque.visible = true;
				this.setVideo();
			}else{
				this.setSound();
				this.rootclip.plaque.visible = false;
			}
			//Botón para votos
			this.rootclip.star.gotoAndStop(1);
			this.rootclip.star.addEventListener(MouseEvent.CLICK, setVote);
			this.rootclip.star.buttonMode = true;
			//Activa los botones de las redes sociales
			this.setButtons();
		}
		
		private function loadUpdate(event:Event):void{
			this.xmlupdate = XML(event.target.data);
			XML.ignoreWhitespace = true;
			this.version = unescape(this.xmlupdate.update.@version).replace(/\+/g," ");
			this.rootclip.versiontext.text = this.version;
			this.important = unescape(this.xmlupdate.update.@important).replace(/\+/g," ");
			if(this.currentversion != this.version){
				if(this.important == "si"){
					trace("Necesita un UPDATE obligatorio");
					this.plaqueupdate = new PU();
					this.rootclip.addChild(this.plaqueupdate);
					this.plaqueupdate.x = this.rootclip.stage.stageWidth / 2;
					this.plaqueupdate.y = this.rootclip.stage.stageHeight / 2 - 50;
					this.plaqueupdate.addEventListener(MouseEvent.CLICK, downloadUpdate);
					this.plaqueupdate.buttonMode = true;
				}else{
					trace("Necesita un UPDATE normal");
					this.rootclip.btversion.versiontext.text = "Versión " + this.version + " está disponible, click aquí";
					this.rootclip.btversion.addEventListener(MouseEvent.CLICK, downloadUpdate);
					this.rootclip.btversion.buttonMode = true;
					this.callNewTrack();
				}
			}else{
				trace("No necesita un UPDATE");
				this.callNewTrack();
			}
		}
		
		private function downloadUpdate(event:MouseEvent):void{
			var targetURL = new URLRequest(this.urldownload);
			navigateToURL(targetURL,"_blank");
		}
		
		private function setVote(event:MouseEvent):void{
			this.rootclip.star.removeEventListener(MouseEvent.CLICK, setVote);
			this.rootclip.star.buttonMode = true;
			//Send and load
			var variables:URLVariables = new URLVariables();
			variables.idtema = this.idtema;
			trace(this.urlvotes);
			var enviar:URLRequest = new URLRequest(this.urlvotes);
			enviar.method = URLRequestMethod.POST;
			enviar.data = variables;
			
			var recibir:URLLoader = new URLLoader();
			recibir.dataFormat = URLLoaderDataFormat.VARIABLES;
			
			recibir.addEventListener(Event.COMPLETE,Respuesta);
			recibir.addEventListener(IOErrorEvent.IO_ERROR,HayError);
			
			recibir.load(enviar);
			
			var rootstage = this;
			
			function Respuesta(event:Event){
				trace("El resultado es : " + recibir.data.result);
				rootstage.rootclip.star.gotoAndStop(2);
			}

			function HayError(event:IOErrorEvent){
				trace("Error al cargar la url");
			}
		}
		
		private function placePlayer():void{
			if(this.apptype == "desktop"){
				this.soundplayer.x = 146;
				this.soundplayer.y = 233;
				this.soundplayer.barra.puntero.y = (this.soundplayer.barra.total.height - this.soundplayer.barra.puntero.height) / 2;
				this.soundplayer.barra.total.width = this.soundplayer.barra;
				this.soundplayer.reproducir.x = 0; 
				this.soundplayer.reproducir.y = 1;
				this.soundplayer.audio.x = 30; 
				this.soundplayer.audio.y = 1;
				this.soundplayer.ecua.x = this.soundplayer.barra.total.width + 110;
			}else if(this.apptype == "bar"){
				this.soundplayer.x = 300;
				this.soundplayer.y = 30;
				this.soundplayer.barra.puntero.y = (this.soundplayer.barra.total.height - this.soundplayer.barra.puntero.height) / 2;
				this.soundplayer.barra.total.width = this.soundplayer.barra;
				this.soundplayer.reproducir.x = 0; 
				this.soundplayer.reproducir.y = 1;
				this.soundplayer.audio.x = 30; 
				this.soundplayer.audio.y = 1;
				this.soundplayer.ecua.x = this.soundplayer.barra.total.width + 85;
			}
			
		}
		
		private function setSound():void{
			this.soundplayer.reproducir.flecha.gotoAndStop(2);
			this.sound = new Sound();
			this.channel = new SoundChannel();
			this.sound.addEventListener(ProgressEvent.PROGRESS, onLoadProgress);
			var context:SoundLoaderContext = new SoundLoaderContext(4000, false);
			var req:URLRequest = new URLRequest(this.media);
			this.sound.load(req);
			this.showPlayer();
		}
		
		
		private function setVideo():void{
			var nc:NetConnection = new NetConnection();
			nc.connect(null);
			this.ns = new NetStream(nc);
			this.ns.bufferTime = 4;
			this.ns.addEventListener(AsyncErrorEvent.ASYNC_ERROR, asyncErrorHandler);
			this.soundplayer.barra.addEventListener(Event.ENTER_FRAME,onLoadVideo);
			this.ns.play(this.media);
			function asyncErrorHandler(event:AsyncErrorEvent):void{
				// omitir error
			}
			this.rootclip.plaque.bacardi.attachNetStream(this.ns);
			//Datos del video
			this.ns.client = new Object();
			this.ns.client.onMetaData = datos;
			var root = this;
			function datos(info:Object):void{
				root.posvideo = info.duration;
			}
			this.showPlayer();
		}
		
		private function onLoadVideo(e:Event){
			var loadedPct = Math.round(100 * (this.ns.bytesLoaded / this.ns.bytesTotal));
			this.soundplayer.barra.precarga.width = (this.ns.bytesLoaded * this.soundplayer.barra.total.width) / this.ns.bytesTotal;
			if(this.ns.bytesLoaded >= this.ns.bytesTotal){
				this.soundplayer.barra.removeEventListener(Event.ENTER_FRAME,onLoadVideo);
			}
		}
		
		private function onLoadProgress(event:ProgressEvent):void{
			var loadedPct = Math.round(100 * (event.bytesLoaded / event.bytesTotal));
			this.soundplayer.barra.precarga.width = (event.bytesLoaded * this.soundplayer.barra.total.width) / event.bytesTotal;
		}
		
		private function showPlayer():void{
			this.statusplay = true;
			this.statusdrag = false;
			this.statusaudio = true;
			this.replay();
			this.soundplayer.reproducir.addEventListener(MouseEvent.CLICK, onClickplay);
			this.soundplayer.audio.addEventListener(MouseEvent.CLICK, onClickaudio);
			
			/*this.soundplayer.barra.puntero.addEventListener(MouseEvent.MOUSE_DOWN, startDragging);
			this.soundplayer.barra.puntero.addEventListener(MouseEvent.MOUSE_UP, stopDragging);
			this.soundplayer.barra.puntero.buttonMode = true;
			this.rootclip.stage.addEventListener(MouseEvent.MOUSE_UP, stopDragging);
			this.soundplayer.barra.addEventListener(MouseEvent.MOUSE_DOWN, setDial);
			this.soundplayer.barra.addEventListener(MouseEvent.MOUSE_UP, stopDragging);*/
			
			this.soundplayer.reproducir.buttonMode = true;
			this.soundplayer.audio.buttonMode = true;
			
		}
		
		private function trackProgress(e:Event){
			this.MoveMarque(this.marque1,this.marque2);
			if(this.statusdrag){
				if(this.type == "audio"){
					//
					this.totaltime = (this.sound.length / this.sound.bytesLoaded) * this.sound.bytesTotal;
					//
					this.position = (this.soundplayer.barra.puntero.x * this.totaltime) / this.soundplayer.barra.total.width;
				}else{
					this.position = (this.soundplayer.barra.puntero.x * this.posvideo) / this.soundplayer.barra.total.width;
				}
				this.soundplayer.barra.parcial.width = this.soundplayer.barra.puntero.x;
			}else{
				if(this.type == "audio"){
					//
					this.totaltime = (this.sound.length / this.sound.bytesLoaded) * this.sound.bytesTotal;
					//
					this.soundplayer.barra.puntero.x = (this.channel.position * this.soundplayer.barra.total.width) / this.totaltime;
				}else{
					this.soundplayer.barra.puntero.x = (this.ns.time * this.soundplayer.barra.total.width) / this.posvideo;
				}
				this.soundplayer.barra.parcial.width = this.soundplayer.barra.puntero.x;
				if(this.soundplayer.barra.puntero.x >= this.soundplayer.barra.total.width - 1){
					this.stopplay();
				}
			}
			//
			if (this.rootclip.mouseX < 5 || this.rootclip.mouseX > this.rootclip.stage.stageWidth - 5 || this.rootclip.mouseY < 5 || this.rootclip.mouseY > this.rootclip.stage.stageHeight - 5) {
         		if(this.statusdrag){
					this.statusdrag = false;
					if(this.type == "audio"){
						this.channel.stop();
						this.channel = this.sound.play(this.position);
					}else{
						this.ns.seek(this.ns.time);
					}
					this.soundplayer.barra.puntero.addEventListener(Event.ENTER_FRAME,trackProgress);
					this.soundplayer.barra.puntero.stopDrag();
				}
 			}
			//
		}
		
		private function replay():void{
			if(this.type == "audio"){
				this.channel = this.sound.play(this.channel.position);
			}else{
				if(!this.statusplay){
					this.ns.seek(this.ns.time);
					this.ns.togglePause();
				}
			}
			this.soundplayer.ecua.gotoAndStop(2);
			this.rootclip.speaker1.play();
			this.rootclip.speaker2.play();
			this.soundplayer.reproducir.flecha.gotoAndStop(2);
			this.soundplayer.barra.puntero.addEventListener(Event.ENTER_FRAME,trackProgress);
		}
		
		private function pauseplay():void{
			this.soundplayer.barra.puntero.removeEventListener(Event.ENTER_FRAME,trackProgress);
			this.soundplayer.ecua.gotoAndStop(1);
			this.soundplayer.reproducir.flecha.gotoAndStop(1);
			this.rootclip.speaker1.gotoAndStop(1);
			this.rootclip.speaker2.gotoAndStop(1);
			if(this.type == "audio"){
				this.channel.stop();
			}else{
				this.ns.togglePause();
			}
		}
		
		private function stopplay():void{
			this.soundplayer.barra.puntero.removeEventListener(Event.ENTER_FRAME,trackProgress);
			this.soundplayer.ecua.gotoAndStop(1);
			this.soundplayer.reproducir.flecha.gotoAndStop(1);
			this.soundplayer.barra.puntero.x = 0;
			this.soundplayer.barra.parcial.width = this.soundplayer.barra.puntero.x;
			if(this.type == "audio"){
				this.channel = this.sound.play(0);
				this.channel.stop();
			}else{
				this.ns.seek(0);
			}
			this.statusplay = false;
			this.callNewTrack();
		}
		
		private function muteAudio():void{
			if(this.statusplay){
				this.onClickplaySound();
			}
		}
		
		private function onClickplay(event:MouseEvent):void{
			this.onClickplaySound();
		}

		public function onClickplaySound():void{	
			if(this.statusplay){
				this.pauseplay();
				this.statusplay = false;
			}else{
				this.replay();
				this.statusplay = true;
				if(this.type == "audio"){
					if(!this.statusaudio){
						var transform1 = new SoundTransform(0);
						this.channel.soundTransform = transform1;
					}
				}
			}
		}
		
		private function onClickaudio(event:MouseEvent):void{
			var sTrans = new SoundTransform();
			if(this.statusaudio){
				this.soundplayer.audio.gotoAndStop(2);
				this.rootclip.speaker1.gotoAndStop(2);
				this.rootclip.speaker2.gotoAndStop(2);
				if(this.type == "audio"){
					var transform1 = new SoundTransform(0);
					this.channel.soundTransform = transform1;
				}else{
					sTrans.volume = 0;
					this.ns.soundTransform = sTrans;
				}
				this.statusaudio = false;
			}else{
				this.soundplayer.audio.gotoAndStop(1);
				this.rootclip.speaker1.play();
				this.rootclip.speaker2.play();
				if(this.type == "audio"){
					var transform2 = new SoundTransform(1);
					this.channel.soundTransform = transform2;
				}else{
					sTrans.volume = 1;
					this.ns.soundTransform = sTrans;
				}
				this.statusaudio = true;
			}
		}
		
		private function startDragging(event:MouseEvent):void{
			if(this.apptype == "desktop"){
				mdm.Forms.getFormByName("bacardi").stopDrag();
			}
			this.statusdrag = true;
			var rectangle:Rectangle = new Rectangle(0, this.soundplayer.barra.puntero.y, this.soundplayer.barra.precarga.width, 0);
			this.soundplayer.barra.puntero.startDrag(false,rectangle);
		}
		
		private function stopDragging(event:MouseEvent):void{
				if(this.statusdrag){
					this.statusdrag = false;
					if(this.type == "audio"){
						this.channel.stop();
						this.channel = this.sound.play(this.position);
					}else{
						this.ns.seek(this.position);
					}
					this.soundplayer.barra.puntero.addEventListener(Event.ENTER_FRAME,trackProgress);
					this.soundplayer.barra.puntero.stopDrag();
				}
		}
		
		private function setDial(event:MouseEvent):void{
			if(this.soundplayer.barra.mouseX < this.soundplayer.barra.precarga.width){
				this.soundplayer.ecua.gotoAndStop(2);
				//this.soundplayer.reproducir.flecha.gotoAndStop(2);
				this.soundplayer.barra.puntero.addEventListener(Event.ENTER_FRAME,trackProgress);
				//this.statusplay = true;
				this.soundplayer.barra.puntero.x = this.soundplayer.barra.mouseX;
				if(this.type == "audio"){
					this.soundplayer.reproducir.flecha.gotoAndStop(2);
					this.statusplay = true;
					this.position = (this.soundplayer.barra.puntero.x * this.totaltime) / this.soundplayer.barra.total.width;
					this.channel.stop();
					this.channel = this.sound.play(this.position);
					this.soundplayer.audio.gotoAndStop(1);
					this.rootclip.speaker1.gotoAndStop(1);
					this.rootclip.speaker2.gotoAndStop(1);
				}else{
					this.position = (this.soundplayer.barra.puntero.x * this.posvideo) / this.soundplayer.barra.total.width;
					this.ns.seek(this.position);
				}
				this.soundplayer.barra.parcial.width = this.soundplayer.barra.puntero.x;
			}
		}
		
	}
}